﻿using System;
using CoreGraphics;
using Foundation;
using Syncfusion.SfCalendar.iOS;
using UIKit;

namespace CalendariOSTesting
{
    public partial class ViewController : UIViewController
    {
        protected ViewController(IntPtr handle) : base(handle)
        {
            // Note: this .ctor should not contain any initialization logic.
        }

        public override void ViewDidLoad()
        {
            SFCalendar cal = new SFCalendar();
            base.ViewDidLoad();
            cal.EnableInLine = true;
            cal.Frame = new CGRect(0, 0, View.Frame.Width, View.Frame.Height);
            SFMonthViewSettings month = new SFMonthViewSettings();
            month.BorderColor = UIColor.Red;
            cal.MonthViewSettings = month;
            cal.Delegate = new calendardelegate(this);
			// Creating instance for schedule appointment collection
			NSMutableArray appCollection = new NSMutableArray();
			NSCalendar calendar = NSCalendar.CurrentCalendar;

			NSDate today = new NSDate();

			// Get the year, month, day from the date
			NSDateComponents startDateComponents = calendar.Components(
			NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);

			// Set the hour, minute, second
			startDateComponents.Hour = 10;
			startDateComponents.Minute = 0;
			startDateComponents.Second = 0;

			// Get the year, month, day from the date
			NSDateComponents endDateComponents = calendar.Components(
			NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);

            // Set the hour, minute, second
            endDateComponents.Day = 12;
			endDateComponents.Hour = 12;
			endDateComponents.Minute = 0;
			endDateComponents.Second = 0;

			//setting start time for the event
			NSDate startDate = calendar.DateFromComponents(startDateComponents);

			//setting end time for the event
			NSDate endDate = calendar.DateFromComponents(endDateComponents);

			//Adding schedule appointment in schedule appointment collection 
            appCollection.Add(new SFAppointment()
			{
				StartTime = startDate,
				EndTime = endDate,
				Subject = (NSString)"Client Meeting",
				
			});

			//Adding schedule appointment in schedule appointment collection 
			cal.Appointments = appCollection;
            View.AddSubview(cal);
            // Perform any additional setup after loading the view, typically from a nib.
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }
        public class calendardelegate : SFCalendarDelegate
        {
            UIViewController alert;
            public calendardelegate(UIViewController view)
            {
                alert = view;
            }

            public override void DidMonthChange(SFCalendar calendar, NSDate navigatedMonth, NSDate previuousMonth)
            {
                var okAlertController = UIAlertController.Create("OK Alert", "Monthchanged Event fired", UIAlertControllerStyle.Alert);

                //Add Action
                okAlertController.AddAction(UIAlertAction.Create("Ok", UIAlertActionStyle.Default, null));
                alert.PresentViewController(okAlertController, true, null);
                // Present Alert
            }
            public override void DidSelectionChange(SFCalendar calendar, NSMutableArray dateRemoved, NSMutableArray dateAdded)
            {
                var okAlertController = UIAlertController.Create("Alert", "Selection changed event fired", UIAlertControllerStyle.Alert);

                //Add Action
                okAlertController.AddAction(UIAlertAction.Create("Ok", UIAlertActionStyle.Default, null));
                alert.PresentViewController(okAlertController, true, null);
            }
        
        }
    }
}
